﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Automation;

//Demo Cached Property

namespace UITestClient
{
    class DemoBusyButton
    {
        public static void InvokeNoSync()
        {
            DateTime startTime = DateTime.Now;

            CacheRequest cacheRequest = new CacheRequest();
            cacheRequest.TreeScope = TreeScope.Element;
            cacheRequest.Add(AutomationElement.NameProperty);

            using (cacheRequest.Activate())
            {
                AutomationElement wpfRoot = AutomationElement.RootElement.FindFirst(TreeScope.Children, new PropertyCondition(AutomationElement.AutomationIdProperty, "Window1"));
                AutomationElement btnBusyButton = wpfRoot.FindFirst(TreeScope.Children, new PropertyCondition(AutomationElement.AutomationIdProperty, "BusyButton"));
                Console.WriteLine(btnBusyButton.Current.Name);
                InvokePattern invokPtn = (InvokePattern)btnBusyButton.GetCurrentPattern(InvokePattern.Pattern);
                for (int i = 1; i <= 5; i++)
                {
                    invokPtn.Invoke();
                    Console.WriteLine("Busy Button Invoked {0} time",i);
                }
                Console.WriteLine(btnBusyButton.Current.Name);
            }

            Console.WriteLine("Test finishes...................");
            Console.WriteLine("Test cost {0} seconds", (DateTime.Now - startTime).TotalSeconds);
        }

        public static void ClickNoSync()
        {
            DateTime startTime = DateTime.Now;

            CacheRequest cacheRequest = new CacheRequest();
            cacheRequest.TreeScope = TreeScope.Element;
            cacheRequest.Add(AutomationElement.NameProperty);

            using (cacheRequest.Activate())
            {
                AutomationElement wpfRoot = AutomationElement.RootElement.FindFirst(TreeScope.Children, new PropertyCondition(AutomationElement.AutomationIdProperty, "Window1"));
                WindowPattern wndptn = (WindowPattern)wpfRoot.GetCurrentPattern(WindowPattern.Pattern);

                var currentStates = wndptn.Current.WindowVisualState;
                if (currentStates != WindowVisualState.Minimized)
                {
                    wndptn.SetWindowVisualState(currentStates);
                }
                else
                {
                    wndptn.SetWindowVisualState(WindowVisualState.Normal);
                }

                AutomationElement btnBusyButton = wpfRoot.FindFirst(TreeScope.Children, new PropertyCondition(AutomationElement.AutomationIdProperty, "BusyButton"));
                Console.WriteLine(btnBusyButton.Current.Name);
                var poi = Clicker.GetClickPoint(btnBusyButton);
             
                for (int i = 1; i <= 5; i++)
                {
                    Clicker.Click(poi);
                    Console.WriteLine("Busy Button Clicked {0} time", i);
                }
                Console.WriteLine(btnBusyButton.Current.Name);
            }

            Console.WriteLine("Test finishes...................");
            Console.WriteLine("Test cost {0} seconds", (DateTime.Now - startTime).TotalSeconds);
        }
    }
}
