﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Automation;

//Demo Cached Property

namespace UITestClient
{
    class DemoCachedProperty
    {
        public static void Test()
        {
            CacheRequest cacheRequest = new CacheRequest();            
            cacheRequest.TreeScope = TreeScope.Element;
            cacheRequest.Add(AutomationElement.NameProperty);

            using (cacheRequest.Activate())
            {
                AutomationElement wpfRoot = AutomationElement.RootElement.FindFirst(TreeScope.Children, new PropertyCondition(AutomationElement.AutomationIdProperty, "Window1"));
                AutomationElement textBlock1 = wpfRoot.FindFirst(TreeScope.Children, new PropertyCondition(AutomationElement.AutomationIdProperty, "TimeBlock"));
                AutomationElement textBlock2 = wpfRoot.FindFirst(TreeScope.Children, new PropertyCondition(AutomationElement.AutomationIdProperty, "TimeBlock"));
                for (int i = 0; i < 100; i++)
                {
                    string cachedName = textBlock1.Cached.Name;
                    string uncachedName = textBlock2.Current.Name;
                    Console.WriteLine("=================");
                    Console.WriteLine("Cached Name is {0}", cachedName);
                    Console.WriteLine("UnCached Name is {0}", uncachedName);
                    System.Threading.Thread.Sleep(300);
                }
            }

            Console.WriteLine("Test finishes...................");
        }
    }
   
}
