﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Automation;

//Demo Cached Property

namespace UITestClient
{
    class DemoClick
    {
        public static void ClickWithWaiterDemo()
        {
            DateTime startTime = DateTime.Now;
            CacheRequest cacheRequest = new CacheRequest();
            cacheRequest.TreeScope = TreeScope.Element;
            cacheRequest.Add(AutomationElement.NameProperty);

            using (cacheRequest.Activate())
            {
                AutomationElement wpfRoot = AutomationElement.RootElement.FindFirst(TreeScope.Children, new PropertyCondition(AutomationElement.AutomationIdProperty, "Window1"));
                WindowPattern wndptn = (WindowPattern)wpfRoot.GetCurrentPattern(WindowPattern.Pattern);

                var currentStates = wndptn.Current.WindowVisualState;
                if (currentStates != WindowVisualState.Minimized)
                {
                    wndptn.SetWindowVisualState(currentStates);
                }
                else
                {
                    wndptn.SetWindowVisualState(WindowVisualState.Normal);
                }
                    
                AutomationElement btnOpenNewWindow = wpfRoot.FindFirst(TreeScope.Children, new PropertyCondition(AutomationElement.AutomationIdProperty, "ButtonOpenFlashWindow"));
                InvokePattern invokPtn = (InvokePattern)btnOpenNewWindow.GetCurrentPattern(InvokePattern.Pattern);

                SimpleWaiter waiter = new SimpleWaiter(WindowPattern.WindowOpenedEvent, AutomationElement.RootElement, TreeScope.Children, new PropertyCondition(AutomationElement.AutomationIdProperty, "FlashWindow"));
                var poi = Clicker.GetClickPoint(btnOpenNewWindow);
                Clicker.Click(poi);
                //invokPtn.Invoke();
                Console.WriteLine("Button Clicked and Wait...");
                waiter.Wait(1000 * 1000);

                AutomationElement newWindow = AutomationElement.RootElement.FindFirst(TreeScope.Children, new PropertyCondition(AutomationElement.AutomationIdProperty, "FlashWindow"));
                Console.WriteLine(newWindow.Current.Name);

                Console.WriteLine("Test finishes...................");
                Console.WriteLine("Test cost {0} seconds", (DateTime.Now - startTime).TotalSeconds);
            }
        }
    }
}
