﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Automation;

//Demo Cached Property

namespace UITestClient
{
    class DemoSimpleEngine
    {
        public static void WPFTargetTest()
        {
            UIWrapper btnOpenFlashWindow = new UIWrapper(@"Window::[Window1]\Button::[ButtonOpenFlashWindow]");
            UIWrapper btnBusyButton = new UIWrapper(@"Window::[Window1]\Button::[BusyButton]");
            UIWrapper flashWindow=new UIWrapper(@"Window::[FlashWindow]");
            UIWrapper btnFlashWindowCloseButton=new UIWrapper(@"Window::[FlashWindow]\Title Bar::[TitleBar]\Button::[Close]");

            DateTime startTime = DateTime.Now;

            for (int i = 0; i < 5; i++)
            {
                btnOpenFlashWindow.Click();
                Console.WriteLine("Flash window opened. Title is: {0}", flashWindow.Name);
                btnFlashWindowCloseButton.Click();

                for (int j = 0; j < 3; j++)
                {
                    btnBusyButton.Invoke();
                    Console.WriteLine("Current busybutton Title is {0}", btnBusyButton.Name);
                }

                Console.WriteLine(i);

            }

            Console.WriteLine("Test finishes...................");
            Console.WriteLine("Test cost {0} seconds", (DateTime.Now - startTime).TotalSeconds);

        }

        public static void CaculatorTest()
        {
            string keys = "+-*/=";

            string[][] oPcharMap = new string[][]
            {
                new string[]{"+","Add"},
                new string[]{"-","Subtract"},
                new string[]{"*","Multiply"},
                new string[]{"/","Divide"},
                new string[]{"=","Equals"}                
            };

            string resultPath = @"Window::Calculator\Pane::\Text::[150]";

            string[] cases = new string[]
            {
                "1+1=",
                "1-1=",
                "1*2=",
                "4/2=",
                "3+2-5=",
            };

            DateTime startTime = DateTime.Now;

            UIWrapper resultText = new UIWrapper(resultPath);

            for(int i=0;i<50;i++)
            {
                foreach (var caseitem in cases)
                {
                    Console.WriteLine("Executing: {0}", caseitem);

                    foreach (char c in caseitem)
                    {
                        StringBuilder sb = new StringBuilder();
                        sb.Append(@"Window::Calculator\Pane::\Button::");

                        if (char.IsDigit(c))
                        {
                            sb.Append(c);
                        }

                        if (keys.Contains(c))
                        {
                            sb.Append(oPcharMap[keys.IndexOf(c)][1]);
                        }

                        UIWrapper btn = new UIWrapper(sb.ToString());
                        btn.Invoke();
                    }
                    Console.WriteLine(i);
                }

                Console.WriteLine("Result in UI: {0}", resultText.Name);  
            }

            Console.WriteLine("Test finishes...................");
            Console.WriteLine("Test cost {0} seconds", (DateTime.Now - startTime).TotalSeconds);

        }
    }
}
