﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Automation;

//Demo Cached Property

namespace UITestClient
{
    class SimpleWaiter
    {
        private AutomationEvent _eventId;
        private AutomationElement _element;
        private TreeScope _scope;
        private System.Threading.AutoResetEvent _event;
        private Condition _condition;
        private AutomationEventHandler _eventHandler;

        public SimpleWaiter(AutomationEvent eventId, AutomationElement element, TreeScope scope, Condition condition)
        {
            this._eventId = eventId;
            this._element = element;
            this._scope = scope;
            this._condition = condition;
            _event = new System.Threading.AutoResetEvent(false);
            _eventHandler = new AutomationEventHandler(Handler);
            Automation.AddAutomationEventHandler(_eventId, _element, _scope, _eventHandler);
        }

        void Handler(object src, AutomationEventArgs e)
        {            
            AutomationElement sourceElement;
            sourceElement = src as AutomationElement;  
            var finditem = sourceElement.FindFirst(TreeScope.Element, _condition);
            if (finditem != null && finditem.Equals(sourceElement))
            {                
                _event.Set();
                Automation.RemoveAutomationEventHandler(_eventId, _element, _eventHandler);
            }            
        }

        public void Wait(int timeOut)
        {
            _event.WaitOne(timeOut);
        }
    }   
}
