﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;


namespace WPFUIAutoTarget
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        private StackPanel pane;
        private TextBlock timeBlock;
        private Button buttonOpenNewWindow;
        private ListBox listboxStringBinding;
        private ListBox listboxManual;
        private SelfDrawControl selfControl;
        private DispatcherTimer tmr=new DispatcherTimer();
        private DispatcherTimer deplyedExecution=new DispatcherTimer();
        private Button kickoffFlashWindow;
        private Button startWinformHoster;
        private Button buttonNoAutomationID;
        private Button busyButton;

        private int busyCount = 0;

        public Window1()
        {
            InitializeComponent();
            this.Name = "Window1";
            CreateControls();
            
        }

        void CreateControls()
        {
            pane = new StackPanel();
            pane.Name = "StackPane";
            this.Content = pane;

            timeBlock = new TextBlock();
            timeBlock.Name = "TimeBlock";
            pane.Children.Add(timeBlock);

            buttonOpenNewWindow = new Button();
            buttonOpenNewWindow.Name = "ButtonOpenNewWindow";
            buttonOpenNewWindow.Content = "Open New Window";
            pane.Children.Add(buttonOpenNewWindow);

            //直接binding的Listbox子元素没有AutomationID
            listboxStringBinding = new ListBox();
            listboxStringBinding.Name = "ListBox_Item_WithoutAutomationID";
            listboxStringBinding.DataContext = new string[] { "1", "2", "3" };
            Binding bind = new Binding();
            bind.Source = new string[] { "1", "2", "3" };             
            listboxStringBinding.SetBinding(ListBox.ItemsSourceProperty, bind);
            pane.Children.Add(listboxStringBinding);
           

            selfControl = new SelfDrawControl();
            selfControl.Name = "SelfDrawControl";
            pane.Children.Add(selfControl);

            listboxManual = new ListBox();
            listboxManual.Name = "ListBox_Item_ManualBindAutomationID";
            for(int i=0;i<5;i++)
            {
                //手动添加的的Listbox子元素可以通过下面的方法指定AutomationID,或者直接指定Name
                ListBoxItem item=new ListBoxItem();
                item.SetValue(System.Windows.Automation.AutomationProperties.AutomationIdProperty, "ManualItem" + i.ToString());
                item.Content =i;
                listboxManual.Items.Add(item);
            }
            pane.Children.Add(listboxManual);

            kickoffFlashWindow = new Button();
            kickoffFlashWindow.Name = "ButtonOpenFlashWindow";
            kickoffFlashWindow.Content = "Kick off Flash Window";
            pane.Children.Add(kickoffFlashWindow);
            kickoffFlashWindow.Click += new RoutedEventHandler(kickoffFlashWindow_Click);

            startWinformHoster = new Button();
            startWinformHoster.Name = "ButtonOpenWinForm";
            startWinformHoster.Content = "Start Winform Hoster";
            pane.Children.Add(startWinformHoster);
            //startWinformHoster.Click += delegate{(new WinFormControlHoster()).ShowDialog();};
            startWinformHoster.Click += new RoutedEventHandler(startWinformHoster_Click);

            tmr.Interval = new TimeSpan(0,0,0,0,500);
            tmr.Tick += delegate { this.timeBlock.Text = DateTime.Now.ToString("U"); };
            tmr.IsEnabled = true;
            buttonOpenNewWindow.Click += new RoutedEventHandler(buttonOpenNewWindow_Click);

            buttonNoAutomationID = new Button();
            buttonNoAutomationID.Content = "Button Wihtout AutomationID";
            pane.Children.Add(buttonNoAutomationID);

            busyButton = new Button();
            busyButton.Name = "BusyButton";
            busyButton.Content = busyCount.ToString();
            pane.Children.Add(busyButton);
            busyButton.Click += new RoutedEventHandler(busyButton_Click);

            deplyedExecution.Interval = new TimeSpan(0, 0, 5);
            deplyedExecution.Tick += new EventHandler(deplyedExecution_Tick);
            deplyedExecution.IsEnabled = false;
        }

        void busyButton_Click(object sender, RoutedEventArgs e)
        {
            busyCount++;
            busyButton.Content = busyCount.ToString();
            for (int i = 1; i < 10; i++)
            {
                System.Threading.Thread.Sleep(150);
            }
        }

        void buttonOpenNewWindow_Click(object sender, RoutedEventArgs e)
        {
            BindingWithAutomationID bwid = new BindingWithAutomationID();
            bwid.ShowDialog();
        }

        void kickoffFlashWindow_Click(object sender, RoutedEventArgs e)
        { 
            deplyedExecution.IsEnabled = true;
        }

        void deplyedExecution_Tick(object sender, EventArgs e)
        {
            FlashWindow fw = new FlashWindow(new TimeSpan(0,0,3));           
            fw.Show();
            deplyedExecution.IsEnabled = false;            
        }

        void startWinformHoster_Click(object sender, RoutedEventArgs e)
        {
            System.Windows.Forms.Form fm = new MyForm();
            fm.ShowDialog();
        } 
    }
}
